﻿//-----------------------------------------------------------------------------------------------------------
//
// THIS CODE AND INFORMATION ARE PROVIDED "AS IS" WITHOUT WARRANTY OF ANY
// KIND, WHETHER EXPRESSED OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE
// IMPLIED WARRANTIES OF MERCHANTABILITY AND/OR FITNESS FOR A PARTICULAR
// PURPOSE.
//
//------------------------------------------------------------------------------------------------------------
using System;
using System.Collections.Generic;
using System.Linq;
using LinqToHbaseProvider;

namespace TestQueries
{

    class Program
    {
        static void Main(string[] args)
        {
            DateTime startTime;
            DateTime endTime;
            TimeSpan ts;

            QueryableHBaseData<AccessRecord> records =
                new QueryableHBaseData<AccessRecord>();

            Console.WriteLine("Scan only");

            startTime = DateTime.Now;

            var query1 = from record in records
                         where record.ipAddress == "88.240.129.183"
                         orderby record.page
                         group record by record.page into grps
                         select new { ip = grps.Key, count = grps.Count() };

            Console.WriteLine("  IP address 88.240.129.183 visted these pages");
            foreach (var pg in query1)
            {
                Console.WriteLine("     page: " + pg.ip + " " + pg.count);
            }
            endTime = DateTime.Now;
            ts = endTime - startTime;
            Console.WriteLine("Elapsed time: " + ts.TotalMilliseconds);

            Console.WriteLine(Environment.NewLine);

            Console.WriteLine("Scan and map/reduce");
            startTime = DateTime.Now;
            var query2 = from record in records
                         where record.ipAddress == "88.240.129.183"
                         from count in HBase.frequency(record)
                         select count;

            Console.WriteLine("  IP address 88.240.129.183 visted these pages");
            foreach (KeyValuePair<string, int> kvp in query2)
            {
                Console.WriteLine("     page: " + kvp.Key + " " + kvp.Value);
            }
            endTime = DateTime.Now;
            ts = endTime - startTime;
            Console.WriteLine("Elapsed time: " + ts.TotalMilliseconds);

            Console.ReadLine();
        }
    }
}
